#include <iostream>
#include <bits/stdc++.h>
using namespace std;

int main()
{
    int n,q,p,x,y,maks;
    vector<int> a;
    vector<int> b;
    cin>>n>>q;
    for(int i=0; i<n; i++){
        cin>>p;
        a.push_back(p);
        b.push_back(1);
    }
    for(int i=0;i<q;i++){
        cin>>x>>y;
        for(int j=x;j<y;j++){
            b[j]= 0;
        }
        for(int j=x-1;j<y;j++){
            for(int l=j;l<y;l++){
                if((a[l] & a[j]) > (a[l] ^ a[j]))
                {
                    b[j]++;
                }
            }
        }
        maks = 0;
        for(int j=x;j<y;j++){
            if(b[j] > maks){
                maks = b[j];
            }
        }
        cout<<maks<<endl;
    }
    return 0;
}